unit Dirs;
interface
uses
   DOS,
   Objects;

const
   rdOk =          0;
   rdError =       1;

type
   TRecurseDirs =
   object(TObject)
      Status       :Word;
      Dir          :DirStr;
      Info         :SearchRec;

      procedure Run(const StartDir     :String);
      procedure ProcessDir; virtual;

   private
      InfoPtr      :^SearchRec;
   end;

   TProcessFiles =
   object(TRecurseDirs)
      FileMask     :String[12];

      constructor Init;

      procedure ProcessDir; virtual;
      procedure ProcessFile; virtual;
   end;

implementation

{ TRecurseDirs }

procedure TRecurseDirs.Run;

procedure ProcessSubdirs;
var
   Subdirs         :PCollection;
   DirIndex        :Integer;
begin
   ProcessDir;
   if Status<>rdOk then Exit;

   New(Subdirs, Init(0, 4));
   FindFirst(Dir+'*.*', Directory, Info);
   while DosError=0 do
   begin
      if (Info.Attr and Directory<>0) and (Info.Name[1]<>'.') then
      begin
         New(InfoPtr); InfoPtr^:=Info;
         Subdirs^.Insert(InfoPtr);
      end;
      FindNext(Info);
   end;

   if DosError<>18 then Status:=rdError else
   for DirIndex:=0 to Subdirs^.Count-1 do
   begin
      InfoPtr:=Subdirs^.At(DirIndex);
      Info:=InfoPtr^;
      Dispose(InfoPtr);

      Dir:=Dir+Info.Name+'\';
      asm
         add  sp,100h
      end;
      ProcessSubdirs;
      asm
         sub  sp,100h
      end;

      if Dir<>'' then
      repeat
         Dec(Dir[0]);
      until (Dir[Length(Dir)]='\') or (Dir='');
   end;

   Subdirs^.DeleteAll;
   Dispose(Subdirs, Done);

   DosError:=0;
end;

begin
   Dir:=StartDir;
   Status:=rdOk;
   ProcessSubdirs;
end;

procedure TRecurseDirs.ProcessDir;
begin
   Abstract;
end;

{ TProcessFiles }

constructor TProcessFiles.Init;
begin
   Inherited Init;

   FileMask:='*.*';
end;

procedure TProcessFiles.ProcessDir;
var
   Files           :PCollection;
   FileIndex       :Integer;
begin
   New(Files, Init(0, 16));
   FindFirst(Dir+FileMask, AnyFile, Info);
   while DosError=0 do
   begin
      if (Info.Attr and (Directory or VolumeId))=0 then
      begin
         New(InfoPtr); InfoPtr^:=Info;
         Files^.Insert(InfoPtr);
      end;
      FindNext(Info);
   end;

   if DosError<>18 then Status:=rdError else
   for FileIndex:=0 to Files^.Count-1 do
   begin
      InfoPtr:=Files^.At(FileIndex);
      Info:=InfoPtr^;
      Dispose(InfoPtr);

      if Status=stOk then ProcessFile;
   end;

   Files^.DeleteAll;
   Dispose(Files, Done);
end;

procedure TProcessFiles.ProcessFile;
begin
   Abstract;
end;

end.

